#include "core.h"

DECLARE_FUNCTION_4P(frho)	REGISTER_FUNCTION(frho, dummy().latex_name("\\rho"))
DECLARE_FUNCTION_4P(fu)		REGISTER_FUNCTION(fu, dummy().latex_name("u"))
DECLARE_FUNCTION_4P(fv)		REGISTER_FUNCTION(fv, dummy().latex_name("v"))
DECLARE_FUNCTION_4P(fw)		REGISTER_FUNCTION(fw, dummy().latex_name("w"))

DECLARE_FUNCTION_4P(fmu0)	REGISTER_FUNCTION(fmu0, dummy().latex_name("\\mmA"))
DECLARE_FUNCTION_4P(fmu1)	REGISTER_FUNCTION(fmu1, dummy().latex_name("\\mmB"))
DECLARE_FUNCTION_4P(fmu2)	REGISTER_FUNCTION(fmu2, dummy().latex_name("\\mmC"))
DECLARE_FUNCTION_4P(fmu3)	REGISTER_FUNCTION(fmu3, dummy().latex_name("\\mmD"))
DECLARE_FUNCTION_4P(fmu4)	REGISTER_FUNCTION(fmu4, dummy().latex_name("\\mmE"))
DECLARE_FUNCTION_4P(fmu5)	REGISTER_FUNCTION(fmu5, dummy().latex_name("\\mmF"))
DECLARE_FUNCTION_4P(fmu6)	REGISTER_FUNCTION(fmu6, dummy().latex_name("\\mmG"))
DECLARE_FUNCTION_4P(fmu7)	REGISTER_FUNCTION(fmu7, dummy().latex_name("\\mmH"))
DECLARE_FUNCTION_4P(fmu8)	REGISTER_FUNCTION(fmu8, dummy().latex_name("\\mmI"))
DECLARE_FUNCTION_4P(fmu9)	REGISTER_FUNCTION(fmu9, dummy().latex_name("\\mmJ"))
DECLARE_FUNCTION_4P(fmu10)	REGISTER_FUNCTION(fmu10, dummy().latex_name("\\mmK"))
DECLARE_FUNCTION_4P(fmu11)	REGISTER_FUNCTION(fmu11, dummy().latex_name("\\mmL"))
DECLARE_FUNCTION_4P(fmu12)	REGISTER_FUNCTION(fmu12, dummy().latex_name("\\mmM"))
DECLARE_FUNCTION_4P(fmu13)	REGISTER_FUNCTION(fmu13, dummy().latex_name("\\mmN"))
DECLARE_FUNCTION_4P(fmu14)	REGISTER_FUNCTION(fmu14, dummy().latex_name("\\mmO"))
DECLARE_FUNCTION_4P(fmu15)	REGISTER_FUNCTION(fmu15, dummy().latex_name("\\mmP"))
DECLARE_FUNCTION_4P(fmu16)	REGISTER_FUNCTION(fmu16, dummy().latex_name("\\mmQ"))
DECLARE_FUNCTION_4P(fmu17)	REGISTER_FUNCTION(fmu17, dummy().latex_name("\\mmR"))
DECLARE_FUNCTION_4P(fmu18)	REGISTER_FUNCTION(fmu18, dummy().latex_name("\\mmS"))
DECLARE_FUNCTION_4P(fmu19)	REGISTER_FUNCTION(fmu19, dummy().latex_name("\\mmT"))
DECLARE_FUNCTION_4P(fmu20)	REGISTER_FUNCTION(fmu20, dummy().latex_name("\\mmU"))
DECLARE_FUNCTION_4P(fmu21)	REGISTER_FUNCTION(fmu21, dummy().latex_name("\\mmV"))
DECLARE_FUNCTION_4P(fmu22)	REGISTER_FUNCTION(fmu22, dummy().latex_name("\\mmW"))
DECLARE_FUNCTION_4P(fmu23)	REGISTER_FUNCTION(fmu23, dummy().latex_name("\\mmX"))
DECLARE_FUNCTION_4P(fmu24)	REGISTER_FUNCTION(fmu24, dummy().latex_name("\\mmY"))
DECLARE_FUNCTION_4P(fmu25)	REGISTER_FUNCTION(fmu25, dummy().latex_name("\\mmZ"))
DECLARE_FUNCTION_4P(fmu26)	REGISTER_FUNCTION(fmu26, dummy().latex_name("\\mmAA"))

DECLARE_FUNCTION_4P(fmueq0)	REGISTER_FUNCTION(fmueq0, dummy().latex_name("\\mmA^{eq}"))
DECLARE_FUNCTION_4P(fmueq1)	REGISTER_FUNCTION(fmueq1, dummy().latex_name("\\mmB^{eq}"))
DECLARE_FUNCTION_4P(fmueq2)	REGISTER_FUNCTION(fmueq2, dummy().latex_name("\\mmC^{eq}"))
DECLARE_FUNCTION_4P(fmueq3)	REGISTER_FUNCTION(fmueq3, dummy().latex_name("\\mmD^{eq}"))
DECLARE_FUNCTION_4P(fmueq4)	REGISTER_FUNCTION(fmueq4, dummy().latex_name("\\mmE^{eq}"))
DECLARE_FUNCTION_4P(fmueq5)	REGISTER_FUNCTION(fmueq5, dummy().latex_name("\\mmF^{eq}"))
DECLARE_FUNCTION_4P(fmueq6)	REGISTER_FUNCTION(fmueq6, dummy().latex_name("\\mmG^{eq}"))
DECLARE_FUNCTION_4P(fmueq7)	REGISTER_FUNCTION(fmueq7, dummy().latex_name("\\mmH^{eq}"))
DECLARE_FUNCTION_4P(fmueq8)	REGISTER_FUNCTION(fmueq8, dummy().latex_name("\\mmI^{eq}"))
DECLARE_FUNCTION_4P(fmueq9)	REGISTER_FUNCTION(fmueq9, dummy().latex_name("\\mmJ^{eq}"))
DECLARE_FUNCTION_4P(fmueq10)	REGISTER_FUNCTION(fmueq10, dummy().latex_name("\\mmK^{eq}"))
DECLARE_FUNCTION_4P(fmueq11)	REGISTER_FUNCTION(fmueq11, dummy().latex_name("\\mmL^{eq}"))
DECLARE_FUNCTION_4P(fmueq12)	REGISTER_FUNCTION(fmueq12, dummy().latex_name("\\mmM^{eq}"))
DECLARE_FUNCTION_4P(fmueq13)	REGISTER_FUNCTION(fmueq13, dummy().latex_name("\\mmN^{eq}"))
DECLARE_FUNCTION_4P(fmueq14)	REGISTER_FUNCTION(fmueq14, dummy().latex_name("\\mmO^{eq}"))
DECLARE_FUNCTION_4P(fmueq15)	REGISTER_FUNCTION(fmueq15, dummy().latex_name("\\mmP^{eq}"))
DECLARE_FUNCTION_4P(fmueq16)	REGISTER_FUNCTION(fmueq16, dummy().latex_name("\\mmQ^{eq}"))
DECLARE_FUNCTION_4P(fmueq17)	REGISTER_FUNCTION(fmueq17, dummy().latex_name("\\mmR^{eq}"))
DECLARE_FUNCTION_4P(fmueq18)	REGISTER_FUNCTION(fmueq18, dummy().latex_name("\\mmS^{eq}"))
DECLARE_FUNCTION_4P(fmueq19)	REGISTER_FUNCTION(fmueq19, dummy().latex_name("\\mmT^{eq}"))
DECLARE_FUNCTION_4P(fmueq20)	REGISTER_FUNCTION(fmueq20, dummy().latex_name("\\mmU^{eq}"))
DECLARE_FUNCTION_4P(fmueq21)	REGISTER_FUNCTION(fmueq21, dummy().latex_name("\\mmV^{eq}"))
DECLARE_FUNCTION_4P(fmueq22)	REGISTER_FUNCTION(fmueq22, dummy().latex_name("\\mmW^{eq}"))
DECLARE_FUNCTION_4P(fmueq23)	REGISTER_FUNCTION(fmueq23, dummy().latex_name("\\mmX^{eq}"))
DECLARE_FUNCTION_4P(fmueq24)	REGISTER_FUNCTION(fmueq24, dummy().latex_name("\\mmY^{eq}"))
DECLARE_FUNCTION_4P(fmueq25)	REGISTER_FUNCTION(fmueq25, dummy().latex_name("\\mmZ^{eq}"))
DECLARE_FUNCTION_4P(fmueq26)	REGISTER_FUNCTION(fmueq26, dummy().latex_name("\\mmAA^{eq}"))

void CORE::log(const char* fmt, ... )
{
        char txt[1024];
        va_list args;
        va_start(args, fmt);
        vsprintf(txt, fmt, args);
        va_end(args);

	mkdir(target_dir,0777);
        char logname[1000];
        sprintf(logname,"%s/_log_%d", target_dir,getpid());
        FILE*f = fopen(logname,"at");
        fprintf(f,txt);
        fclose(f);

        printf(txt);
        fflush(stdout);
}

void CORE::prepare_EFDE_load_table(symtab &table)
{
	table[lbm.sym_o.get_name()] = lbm.sym_o;
	table[dt.get_name()] = dt;
	table[dl.get_name()] = dl;
	for (int i=0;i<3;i++) table[sym_vel[i].get_name()] = sym_vel[i];
	for (int i=0;i<MQ;i++)
	{
		if (pde_strategy==NSE && use_NSE_omegas && i < DIM+1)
			table[lbm.sym_os[i].get_name()] = (ex)1;
		else
			table[lbm.sym_os[i].get_name()] = lbm.sym_os[i];
	}

	for (int i=0;i<MQ;i++)
	for (int d=0;d<DIM;d++)
		table[symA[d][i].get_name()] = symA[d][i];

	for (int l=0;l<L;l++)
	for (int iz=-(l+1);(iz<=l+1 && DIM==3) || (iz<=-(l+1));iz++)
	for (int iy=-(l+1);(iy<=l+1 && DIM>=2) || (iy<=-(l+1));iy++)
	for (int ix=-(l+1);ix<=l+1;ix++)
	if (isin(l,ix,iy,iz))
		for (int d=0;d<DIM;d++)
			table[ sym_vels[d][index(l,ix,iy,iz)].get_name() ] = sym_vels[d][index(l,ix,iy,iz)];
}

void CORE::set_optimal_pars(int pde, lst &list)
{
	// put everything in here
	if (Q==3)
	{
		switch (collision_model)
		{
		case SRT:
			if (pde==0)
			{
				list.append( symA[0][0] == -lbm.sym_o + 1 );
				list.append( symA[0][1] == lbm.sym_o - 1 );
				list.append( symA[0][2] == 0 );
			} else
			{
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == lbm.sym_o - 1 );
				list.append( symA[0][2] == -lbm.sym_o + 1 );
			}
			break;
		case MRT1:
			if (pde==0)
			{
				list.append( symA[0][0] == -( lbm.sym_os[1] - 1) );
				list.append( symA[0][1] == ( lbm.sym_os[1]-1 ) );
				list.append( symA[0][2] == 0 );
			} else
			{
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == (lbm.sym_os[1]+lbm.sym_os[2])/2-1 );
				list.append( symA[0][2] ==  -(lbm.sym_os[1]+lbm.sym_os[2])/2+1 );
			}
			break;
		case CLBM1:
			if (pde==0)
			{
				list.append( symA[0][0] == -( lbm.sym_os[1] - 1) );
				list.append( symA[0][1] == ( lbm.sym_os[1]-1 ) );
				list.append( symA[0][2] == 0 );
			} else
			{
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] ==   (lbm.sym_os[1]+lbm.sym_os[2])/2-1 + (lbm.sym_os[1]-lbm.sym_os[2])*sym_vel[0] );
				list.append( symA[0][2] ==  -(lbm.sym_os[1]+lbm.sym_os[2])/2+1  + (lbm.sym_os[1]-lbm.sym_os[2])*sym_vel[0] );
			}
			break;
		}
	}
	if (Q==9)
	{
		switch (collision_model)
		{
		case SRT:
		{
			ex gamma = lbm.sym_o - 1;
			switch(pde)
			{
				case 0:
				// A0 = 0, B0 = 0, A1 = 0, B1 = 0, A2 = 0, B2 = 0, A3 = 0, B3 = 0, A4 = 0, B4 = 0, A5 = 0, B5 = 0, A6 = 0, 
				// B6 = -1/2+(1/2)*o, A7 = 1/2-(1/2)*o, B7 = 1/2-(1/2)*o, A8 = -1/2+(1/2)*o, B8 = 0
				// "A"
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == 0 );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == 0 );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == 0 );
				list.append( symA[0][7] == - gamma/2 );
				list.append( symA[0][8] == gamma/2  );
				// "B"
				list.append( symA[1][0] == 0 );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == 0 );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == gamma/2 );
				list.append( symA[1][7] == - gamma/2 );
				list.append( symA[1][8] == 0 );
				break;
			case 1:
				// A0 = 0, B0 = 0, A1 = 0, B1 = 0, A2 = 0, B2 = 0, A3 = 0, B3 = 0, A4 = 0, B4 = 0, A5 = 0, B5 = 0, 
				// A6 = 7/2-(7/2)*o, B6 = (1/2)*o-1/2, A7 = (1/2)*o-1/2, B7 = -(1/2)*o+1/2, A8 = -4+4*o, B8 = 0
				// "A"
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == 0 );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == 0 );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == -gamma*(ex)7/(ex)2 );
				list.append( symA[0][7] == gamma/2 );
				list.append( symA[0][8] == gamma*4 );
				// "B"
				list.append( symA[1][0] == 0 );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == 0 );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == gamma/2 );
				list.append( symA[1][7] == -gamma/2 );
				list.append( symA[1][8] == 0 );
			break;
			case 2:
				// A0 = 0, B0 = 0, A1 = 0, B1 = 0, A2 = 0, B2 = 0, A3 = 0, B3 = 0, A4 = 0, B4 = 0, A5 = 0, B5 = 0,
				// A6 = 0, B6 = 4*o-4, A7 = -(1/2)*o+1/2, B7 = (1/2)*o-1/2, A8 = (1/2)*o-1/2, B8 = -(7/2)*o+7/2
				// "A"
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == 0 );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == 0 );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == 0 );
				list.append( symA[0][7] == -gamma/2 );
				list.append( symA[0][8] == gamma/2 );
				// "B"
				list.append( symA[1][0] == 0 );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == 0 );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == gamma*4 );
				list.append( symA[1][7] == gamma/2 );
				list.append( symA[1][8] == -gamma*(ex)7/(ex)2  );
			break;
			case 4:
				// K0 = 0, L0 = 0, K1 = 1/2, L1 = -1, K2 = 0, 0 = 0, K3 = -1/2, 0 = 0, K4 = 0, 0 = 0, K5 = 0, L5 = 1, 
				// K6 = 0, 0 = 0, K7 = 0, L7 = 0, K8 = 0, L8 = 0
				// A = gamma * K, B = gamma * L
				// "A"
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == gamma/2 );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == -gamma/2 );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == 0 );
				list.append( symA[0][7] == 0 );
				list.append( symA[0][8] == 0 );
				// "B"
				list.append( symA[1][0] == 0 );
				list.append( symA[1][1] == -gamma );
				list.append( symA[1][2] == 0 );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == gamma );
				list.append( symA[1][6] == 0 );
				list.append( symA[1][7] == 0 );
				list.append( symA[1][8] == 0 );
			break;
			case 5: // A0 = 0, B0 = 0, A1 = o-1, B1 = 0, A2 = 0, B2 = o-1, A3 = -o+1, B3 = 0, A4 = 2*o-2, B4 = 0, A5 = 0, B5 = 0, 
				// A6 = (5/2)*o-5/2, B6 = (1/3)*o-1/3, A7 = -(1/2)*o+1/2, B7 = 0, A8 = 0, B8 = 0
				// "A"
				list.append( symA[0][0] == 0 );
				list.append( symA[0][1] == gamma );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == -gamma );
				list.append( symA[0][4] == gamma*2 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == gamma*(ex)5/(ex)2 );
				list.append( symA[0][7] == -gamma/2 );
				list.append( symA[0][8] == 0 );
				// "B"
				list.append( symA[1][0] == 0 );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == gamma );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == gamma/3 );
				list.append( symA[1][7] == 0 );
				list.append( symA[1][8] == 0 );
			break;
			case 8:
				// A0 = -o+1, B0 = -o+1, A1 = o-1, B1 = 0, A2 = 0, B2 = o-1, A3 = 0, B3 = 0, A4 = 0, 0 = 0, A5 = 0, 
				// B5 = 0, A6 = 0, B6 = 0, A7 = 0, B7 = 0, A8 = 0, B8 = 0
				// "A"
				list.append( symA[0][0] == -gamma );
				list.append( symA[0][1] == gamma );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == 0 );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == 0 );
				list.append( symA[0][7] == 0 );
				list.append( symA[0][8] == 0 );
				// "B"
				list.append( symA[1][0] == -gamma );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == gamma );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == 0 );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == 0 );
				list.append( symA[1][7] == 0 );
				list.append( symA[1][8] == 0 );
			break;
			case 3:
			case 6:
			case 7:
				// "A"
				list.append( symA[0][0] == gamma );
				list.append( symA[0][1] == 0 );
				list.append( symA[0][2] == 0 );
				list.append( symA[0][3] == -gamma );
				list.append( symA[0][4] == 0 );
				list.append( symA[0][5] == 0 );
				list.append( symA[0][6] == 0 );
				list.append( symA[0][7] == 0 );
				list.append( symA[0][8] == 0 );
				// "B"
				list.append( symA[1][0] == gamma );
				list.append( symA[1][1] == 0 );
				list.append( symA[1][2] == 0 );
				list.append( symA[1][3] == 0 );
				list.append( symA[1][4] == -gamma );
				list.append( symA[1][5] == 0 );
				list.append( symA[1][6] == 0 );
				list.append( symA[1][7] == 0 );
				list.append( symA[1][8] == 0 );
			break;
			}
		} // SRT
		}
	}
}

void CORE::load_optimal_pars()
{
	if (optimal_pars_loaded) return;
	for (int q=0;q<Q;q++) set_optimal_pars(q, optimal_pars[q]);
	optimal_pars_loaded=true;
}

void CORE::find_optimal_pars(int pde, int lfrom, int lto)
{
	// prepare table for EFDE coefs load
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);
	matrix efde_coefs=matrix(Q,Q), efde_coefs_eq=matrix(Q,Q);

	lst eqns, vars;

	cout << "# MAPLE/MAXIMA INPUT:"<<endl;
	cout << "set"<<pde<<":=[";
	bool first=true;
	for (int l=lfrom;l<=lto;l++)
	for (int i3=-l-1;(i3<=l+1 && DIM==3) || (i3<=-l-1);i3++)
	for (int i2=-l-1;(i2<=l+1 && DIM>=2) || (i2<=-l-1);i2++)
	for (int i1=-l-1;i1<=l+1;i1++)
	if (isin(l,i1,i2,i3))
	{
		load_EFDE_coefs(efde_coefs, pde, l, i1, i2, i3, "efde_coefs", reader, false);
		load_EFDE_coefs(efde_coefs_eq, pde, l, i1, i2, i3, "efde_coefs_eq", reader, false);
		for (int q=0;q<Q;q++)
		{
			if (efde_coefs(pde,q)!=0)
			{
				if (first) first=false; else cout << ",";
				cout << efde_coefs(pde,q) << "=0";  //eqns.append( efde_coefs(pde,q) == 0 );
			}
			if (efde_coefs_eq(pde,q)!=0) //eqns.append( efde_coefs_eq(pde,q) == 0 );
			{
				if (first) first=false; else cout << ",";
				cout << efde_coefs_eq(pde,q) << "=0";  //eqns.append( efde_coefs(pde,q) == 0 );
			}
		}
	}
	cout << "]:"<<endl;
	cout << "vars:=[";
	first=true;
	for (int q=0;q<Q;q++)
	for (int d=0;d<DIM;d++)
	{
		if (first) first=false; else cout << ",";
		cout << symA[d][q];
	}
	cout << "];"<<endl;
	// GINAC does not have this implemented ...
//	cout << "list to solve: "<<endl<<eqns<<endl;
//	cout << "list of vars: "<<endl<<vars<<endl;
//	cout << solve( eqns, vars ) << endl;
}

////////////////////////////////////////////////////////////////////////////////////////////
//
// STEP 00: Init
//
////////////////////////////////////////////////////////////////////////////////////////////


void CORE::coord2str(char *str, char*str_tex, int t, int x, int y, int z)
{
	char sx[20],sy[20],sz[20],st[20];
	// tex!
	if (t<0) sprintf(st,"\\bar%d",-t); else sprintf(st,"%d",t);
	if (x<0) sprintf(sx,"\\bar%d",-x); else sprintf(sx,"%d",x);
	if (y<0) sprintf(sy,"\\bar%d",-y); else sprintf(sy,"%d",y);
	if (z<0) sprintf(sz,"\\bar%d",-z); else sprintf(sz,"%d",z);

	sprintf(str_tex,"%s",st);
	if (DIM==1) sprintf(str_tex,"%s,%s",str_tex,sx);
	if (DIM==2) sprintf(str_tex,"%s,%s,%s",str_tex,sx,sy);
	if (DIM==3) sprintf(str_tex,"%s,%s,%s,%s",str_tex,sx,sy,sz);

	// normal
	if (t==0) sprintf(st,"z"); else { if (t<0) sprintf(st,"m%d",-t); else sprintf(st,"p%d",t); }
	if (x==0) sprintf(sx,"z"); else { if (x<0) sprintf(sx,"m%d",-x); else sprintf(sx,"p%d",x); }
	if (y==0) sprintf(sy,"z"); else { if (y<0) sprintf(sy,"m%d",-y); else sprintf(sy,"p%d",y); }
	if (z==0) sprintf(sz,"z"); else { if (z<0) sprintf(sz,"m%d",-z); else sprintf(sz,"p%d",z); }

	sprintf(str,"%s",st);
	if (DIM==1) sprintf(str,"%s%s",str,sx);
	if (DIM==2) sprintf(str,"%s%s%s",str,sx,sy);
	if (DIM==3) sprintf(str,"%s%s%s%s",str,sx,sy,sz);
}

void CORE::desc2str(char *str, int k, int j1, int j2, int j3)
{
	int j=j1+j2+j3;
	char str_i1[50], str_i2[50], str_i3[50], str_t[50];
	sprintf(str,"1");
	if (k-j>0) { if (k-j==1) sprintf(str_t,"t"); else sprintf(str_t,"t^{%d}",k-j); } else sprintf(str_t,"");
	if (j1>0) { if (j1==1) sprintf(str_i1,"x"); else sprintf(str_i1,"x^{%d}",j1); } else sprintf(str_i1,"");
	if (j2>0) { if (j2==1) sprintf(str_i2,"y"); else sprintf(str_i2,"y^{%d}",j2); } else sprintf(str_i2,"");
	if (j3>0) { if (j3==1) sprintf(str_i3,"z"); else sprintf(str_i3,"z^{%d}",j3); } else sprintf(str_i3,"");
	if (k>0) sprintf(str,"%s%s%s%s",str_t,str_i1,str_i2,str_i3);
}

void CORE::desc2str2(char *str, int k, int j1, int j2, int j3)
{
	int j=j1+j2+j3;
	char str_x[50], str_y[50], str_z[50], str_t[50];
	sprintf(str,"1");
	sprintf(str_t,"");	for (int w=0;w<k-j;w++) sprintf(str_t,"%st", str_t);
	sprintf(str_x,"");	for (int w=0;w<j1;w++) sprintf(str_x,"%sx", str_x);
	sprintf(str_y,"");	for (int w=0;w<j2;w++) sprintf(str_y,"%sy", str_y);
	sprintf(str_z,"");	for (int w=0;w<j3;w++) sprintf(str_z,"%sz", str_z);
	if (k>0) sprintf(str,"%s%s%s%s",str_t,str_x,str_y,str_z);
}

void CORE::number2str(char *str, const char *s1, const char *s2, int number)
{
	if (number==0) { sprintf(str,"%s",s1); return; }
	if (number==1) { sprintf(str,"%s+%s",s1,s2); return; }
	if (number==-1) { sprintf(str,"%s-%s",s1,s2); return; }
	if (number<0) { sprintf(str,"%s%d%s",s1,number,s2); return; }
	if (number>0) { sprintf(str,"%s+%d%s",s1,number,s2); return; }
}

void CORE::desc2str(char *s_space_coeff, char* s_time_coeff, char* s_space_formula, char* s_time_formula, int l, int i1, int i2, int i3)
{
	char str_t[50], str_i1[50], str_i2[50], str_i3[50];
	number2str(str_t,"t","\\dt",-l);
	number2str(str_i1,"x","\\dl",i1);
	number2str(str_i2,"y","\\dl",i2);
	number2str(str_i3,"z","\\dl",i3);

	sprintf(s_time_coeff, "{%d}",l);
	sprintf(s_time_formula, "{%s}",str_t);
	// fix
	sprintf(s_time_coeff, "%s",s_time_formula);
	switch (DIM)
	{
		case 1:
			sprintf(s_space_coeff, "{%d}",i1);
			sprintf(s_space_formula, "{%s}",str_i1);
			break;
		case 2:
			sprintf(s_space_coeff, "{%d,%d}",i1,i2);
			sprintf(s_space_formula, "{%s, %s}",str_i1,str_i2);
			break;
		case 3: sprintf(s_space_coeff, "{%d,%d,%d}",i1,i2,i3);
			sprintf(s_space_formula, "{%s, %s, %s}",str_i1,str_i2,str_i3);
			break;
	}
}

void CORE::taylor_list_vels(lst &list)
{
	for (int l=0;l<L;l++)
	for (int iz=-(l+1);(iz<=l+1 && DIM==3) || (iz<=-(l+1));iz++)
	for (int iy=-(l+1);(iy<=l+1 && DIM>=2) || (iy<=-(l+1));iy++)
	for (int ix=-(l+1);ix<=l+1;ix++)
	if (isin(l,ix,iy,iz))
		for (int d=0;d<DIM;d++)
			list.append( sym_vels[d][index(l,ix,iy,iz)] == tay_vels[d]->sub[index(l,ix,iy,iz)] );
}

void CORE::taylor_list_vels_functions(lst &list)
{
	for (int d=0;d<DIM;d++)
	{
		int O=tay_vels[d]->ORDER;
		for (int k1=0;k1<=O;k1++)
		for (int k2=0;k2<=O;k2++)
		for (int k3=0;k3<=O;k3++)
		for (int k4=0;k4<=O;k4++)
			list.append(tay_vels[d]->get_tay(k1,k2,k3,k4) == diff(diff(diff(diff(f_vel[d],t,k1),x,k2),y,k3),z,k4)*pow(dt,k1)*pow(dl,k2+k3+k4));
	}
}

void CORE::taylor_list_vels_moments(lst &list)
{
	int iter=0;
	for (int d=0;d<DIM;d++)
	{
		int O=tay_vels[d]->ORDER;
		for (int k1=0;k1<=O;k1++)
		for (int k2=0;k2<=O;k2++)
		for (int k3=0;k3<=O;k3++)
		for (int k4=0;k4<=O;k4++)
			list.append(tay_vels[d]->get_tay(k1,k2,k3,k4) == diff(diff(diff(diff(f_mu[d]/f_mu[0],t,k1),x,k2),y,k3),z,k4)*pow(dt,k1)*pow(dl,k2+k3+k4));
	}
}


void CORE::allocate()
{
	// get constmatrixA info
	if (collision_model == SRT) // SRT only
		numericmatrixA = true;
	constmatrixA = true;
	if (!constvel) constmatrixA = lbm.is_const_matrix(collision_model); // A_CLBM1,2 are non-constant matrices
	// decide what to use here
	use_tay_vels = false;
	if (!constmatrixA) use_tay_vels = true; // only CLBM!!!

	// set collision model description
	lbm.set_model_desc(model_desc, collision_model);
	printf("||| allocate: model d%dq%d with collision %s, constmatrixA: %d use_tay_vels: %d\n",DIM,Q,model_desc,constmatrixA, use_tay_vels);

	// fill in symbols
	char desc[1000], s[100], s_tex[100], desc2[20],desc3[20], desc_tex[1000];

	As = new matrix[Nindex];
	// prepare symbolic matrices

	symB = new symbol[MQ*MQ];
	for (int i=0;i<MQ*MQ;i++)
	{
		sprintf(desc, "bb%d",i);
		symB[i] = symbol(desc);
	}

	sym_cs = symbol("c_s");

	sym_vel[0] = symbol("u");
	sym_vel[1] = symbol("v");
	sym_vel[2] = symbol("w");

	sym_vels = new symbol*[DIM];
	for (int d=0;d<DIM;d++) sym_vels[d] = new symbol[Nindex];

	char s_space_coeff[100],s_time_coeff[100],s_space_formula[100], s_time_formula[100];
	for (int l=0;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z))
	{
		if (constvel)
		{
			for (int d=0;d<DIM;d++) sym_vels[d][index(l,x,y,z)] = sym_vel[d];
		} else
		{
			coord2str(s,s_tex,-l,x,y,z);
			desc2str(s_space_coeff, s_time_coeff, s_space_formula, s_time_formula, l, x, y, z);

			sprintf(desc,"u_%s",s);
			sprintf(desc_tex,"u_{%s}",s_tex);
			sym_vels[0][index(l,x,y,z)] = symbol(desc, desc_tex);
			if (DIM>=2)
			{
				sprintf(desc,"v_%s",s);
				sprintf(desc_tex,"v_{%s}",s_tex);
				sym_vels[1][index(l,x,y,z)] = symbol(desc, desc_tex);
			}
			if (DIM==3)
			{
				sprintf(desc,"w_%s",s);
				sprintf(desc_tex,"w_{%s}",s_tex);
				sym_vels[2][index(l,x,y,z)] = symbol(desc, desc_tex);
			}
		}

		if (l==0)
		if ((DIM==1 && x==0) || (DIM==2 && x==0 && y==0) || (DIM==3 && x==0 && y==0 && z==0))
		{
			for (int d=0;d<DIM;d++)
				sym_vels[d][index(l,x,y,z)] = sym_vel[d];
		}
	}

	if (verbosity>=2) printf("allocate: matrices\n");

	// identity matrix
	I = matrix(Q,Q);
	empty_matrix(I);
	for (int i=0;i<Q;i++)
		I(i,i) = 1;

	// matrices E
	for (int m=0;m<Q;m++)
	{
		E[m] = matrix(Q,Q);
		for (int i=0;i<Q;i++)
		for (int j=0;j<Q;j++)
			E[m](i,j) = (i==j && j==m) ? 1 : 0;
	}

	// Matrix C that defines discrete velocities
	C = matrix(DIM,Q);
	lbm.setC(C,Q);

	for (int i=0;i<DIM;i++)
	{
		for (int j=0;j<Q;j++)
		{
			CC[i][j]=0;
			if (C(i,j)>0) CC[i][j] = 1;
			if (C(i,j)<0) CC[i][j] = -1;
			if (verbosity>=2) printf("C[%d,%d]=%d ",i,j,CC[i][j]);
		}
		if (verbosity>=2) printf("\n");
	}

	// set all entries to zero
	for (int q=0;q<Q;q++)
	{
		e[q] = matrix(Q,1);
		empty_matrix(e[q],Q,1);
		e[q](q,0)=(ex)1;
	}

	// define matrix M
	M = matrix(Q,Q);
	Mi = matrix(Q,Q);
	lbm.setM(M, Q);
	Mi = inverse(M);

	// define matrix A
	define_matrix_A();
	allocated=true;

	// subs vels: for latex output
	subs_vels.append( f_rho == symbol("\\rho") );
	subs_vels.append( f_vel[0] == symbol("u") );
	subs_vels.append( f_vel[1] == symbol("v") );
	subs_vels.append( f_vel[2] == symbol("w") );

	// allocate symbols
	for (int q=0;q<Q;q++)
	for (int d=0;d<DIM;d++)
	{
		sprintf(desc, "%c%d",'A'+d,q);
		symA[d][q] = symbol(desc);
	}
}

void CORE::allocate_Taylor()
{
	if (allocated_tay) return;
	cout << "||| allocate_Taylor"<<endl;
	// fill in symbols
	char desc[1000], s[20], desc2[20],desc3[20];
	if (use_tay_vels)
	{
		tay_vels = new TAYLOR*[DIM];
		if (verbosity>=2) printf("allocate_Taylor: tay_vels\n");
		for (int d=0;d<DIM;d++) tay_vels[d] = new TAYLOR(DIM,Q,ORDER,_index,Nindex,dl,dt);
		if (DIM>=1) tay_vels[0]->allocate("u", sym_vel[0]);
		if (DIM>=2) tay_vels[1]->allocate("v", sym_vel[1]);
		if (DIM>=3) tay_vels[2]->allocate("w", sym_vel[2]);
	}
	allocated_tay=true;
}

void CORE::define_matrix_A_worker(matrix &_A, ex u, ex v, ex w)
{
	switch (collision_model)
	{
		case SRT: lbm.setA_SRT(_A,Q,u,v,w); break;
		case MRT1: lbm.setA_MRT1(_A,Q,u,v,w); break;
		case MRT2: lbm.setA_MRT2(_A,Q,u,v,w); break;
		case CLBM1: lbm.setA_CLBM1(_A,Q,u,v,w); break;
		case CLBM2: lbm.setA_CLBM2(_A,Q,u,v,w); break;
		case MRT1_OG: lbm.setA_MRT1_OG(_A,Q,u,v,w); break;
		case MRT2_OG: lbm.setA_MRT2_OG(_A,Q,u,v,w); break;
		case CLBM1_OG: lbm.setA_CLBM1_OG(_A,Q,u,v,w); break;
		case CLBM2_OG: lbm.setA_CLBM2_OG(_A,Q,u,v,w); break;
		case GENERAL: lbm.setA_GENERAL(_A,Q,u,v,w); break;
	}
}

void CORE::define_matrix_A()
{
	// define matrix A: central matrix at [0,0,0]: A_0: A_t^x
	A = matrix(Q,Q);
	empty_matrix(A);
	define_matrix_A_worker(A,sym_vel[0],sym_vel[1],sym_vel[2]);
	simplify_matrix(A);

	if (!constmatrixA)
	{
		empty_matrix(A);
		if (DIM==1) define_matrix_A_worker(A,sym_vels[0][index(0,0,0,0)],0,0);
		if (DIM==2) define_matrix_A_worker(A,sym_vels[0][index(0,0,0,0)],sym_vels[1][index(0,0,0,0)],0);
		if (DIM==3) define_matrix_A_worker(A,sym_vels[0][index(0,0,0,0)],sym_vels[1][index(0,0,0,0)],sym_vels[2][index(0,0,0,0)]);
		simplify_matrix(A);

		for (int l=0;l<L;l++)
		{
			for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
			for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
			for (int x=-(l+1);x<=l+1;x++)
			if (isin(l,x,y,z))
			{
				As[index(l,x,y,z)] = matrix(Q,Q);
				ex u=0,v=0,w=0;
				u=sym_vels[0][index(l,x,y,z)];
				if (DIM>=2) v = sym_vels[1][index(l,x,y,z)];
				if (DIM>=3) w = sym_vels[2][index(l,x,y,z)];
				define_matrix_A_worker(As[index(l,x,y,z)],u,v,w);
				simplify_matrix(As[index(l,x,y,z)]);
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////
//
// STEP 01: compute LBMAN matrices
//
////////////////////////////////////////////////////////////////////////////////////////////
void CORE::find_optimal_coefficients(matrix &I_A, ex *par, int i)
{
	if (pde_strategy==ADE)
	{
		par[0] = -I_A(i,i);
		for (int d=1;d<DIM+1;d++) par[d] = 0;
		return;
	}
	if (use_NSE_strategies)
	{
		// determine the stratgy outside this code [Maxima/Maple]
		for (int d=1;d<DIM+1;d++) par[d] = 0;
		for (int d=0;d<DIM;d++) par[1+d] = symA[d][i];
		par[0] = -I_A(i,i);
		for (int d=0;d<DIM;d++) par[0] -= par[d+1]*M(d+1,i);
		return;
	}

	// maximalize the number of zeros in the resulting matrix
	//
	//for (int i=0;i<Q;i++)
	// work on row i
	matrix W = matrix( Q, DIM);
	matrix RHS = matrix( Q, 1);
	for (int j=0;j<Q;j++)
	{
		for (int d=0;d<DIM;d++) W(j,d) =M(d+1,j) - M(d+1,i);
		RHS( j, 0 ) = I_A(i,i) - I_A(i,j);
	}

	// find all solutions possible and count zeros
	int maxzeros=0;
	ex optsol[MDIM];
	ex e=0;
	ex xi[MDIM];
	char desc[100];
	for (int d=0;d<DIM;d++)
	{
		sprintf(desc,"xi%d",d);
		xi[d] = symbol(desc);
	}
	for (int d=0;d<DIM;d++) optsol[d]=0;

	switch (DIM)
	{
		case 1:{
			for (int i1=0;i1<Q;i1++)
			{
				lst eqns, vars;
				e=0;
				for (int d=0;d<DIM;d++) e += W(i1,d)*xi[d];
				eqns.append( e == RHS(i1,0) );
				vars.append( xi[0] );
				ex sol = lsolve(eqns, vars);
				if (sol!=0)
				{
					matrix XI = matrix(DIM, 1);
					for (int d=0;d<DIM;d++) XI(d,0) = subs( xi[d],  sol );
					matrix RES = W.mul(XI);
					// count zeros
					int zeros=0;
					for (int q=0;q<Q;q++) if (normal(RES(q,0)-RHS(q,0))==0) zeros++;
					if (zeros>maxzeros)
					{
						for (int d=0;d<DIM;d++) optsol[d] = expand(XI(d,0));
						maxzeros=zeros;
					}
				}
			}
		} break;
		case 2:{
			for (int i1=0;i1<Q;i1++)
			for (int j1=i1+1;j1<Q;j1++)
			{
				lst eqns, vars;
				e=0;
				for (int d=0;d<DIM;d++) e += W(i1,d)*xi[d];
				eqns.append( e == RHS(i1,0) );
				vars.append( xi[0] );
				e=0;
				for (int d=0;d<DIM;d++) e += W(j1,d)*xi[d];
				eqns.append( e == RHS(j1, 0) );
				vars.append( xi[1] );
				ex sol = lsolve(eqns, vars);
				if (sol!=0)
				{
					matrix XI = matrix(DIM, 1);
					for (int d=0;d<DIM;d++) XI(d,0) = subs( xi[d],  sol );
					matrix RES = W.mul(XI);
					// count zeros
					int zeros=0;
					for (int q=0;q<Q;q++) if (normal(RES(q,0)-RHS(q,0))==0) zeros++;
					if (zeros>maxzeros)
					{
						for (int d=0;d<DIM;d++) optsol[d] = expand(XI(d,0));
						maxzeros=zeros;
					}
				}
			}
		} break;
		case 3:{
			for (int i1=0;i1<Q;i1++)
			for (int j1=i1+1;j1<Q;j1++)
			for (int k1=j1+1;k1<Q;k1++)
			{
				lst eqns, vars;
				e=0;
				for (int d=0;d<DIM;d++) e += W(i1,d)*xi[d];
				eqns.append( e == RHS(i1,0) );
				vars.append( xi[0] );
				e=0;
				for (int d=0;d<DIM;d++) e += W(j1,d)*xi[d];
				eqns.append( e == RHS(j1, 0) );
				vars.append( xi[1] );
				e=0;
				for (int d=0;d<DIM;d++) e += W(k1,d)*xi[d];
				eqns.append( e == RHS(k1, 0) );
				vars.append( xi[2] );
				ex sol = lsolve(eqns, vars);
				if (sol!=0)
				{
					matrix XI = matrix(DIM, 1);
					for (int d=0;d<DIM;d++) XI(d,0) = subs( xi[d],  sol );
					matrix RES = W.mul(XI);
					// count zeros
					int zeros=0;
					for (int q=0;q<Q;q++) if (normal(RES(q,0)-RHS(q,0))==0) zeros++;
					if (zeros>maxzeros)
					{
						for (int d=0;d<DIM;d++) optsol[d] = expand(XI(d,0));
						maxzeros=zeros;
					}
				}
			}
		} break;
	}
	cout <<"for i="<<i<<" maxzeros found " << maxzeros << " for ";
	par[0] = -I_A(i,i);
	for (int d=0;d<DIM;d++)
	{
		cout << optsol[d] << " ";
		par[d+1] = optsol[d];
		par[0] -= optsol[d]*M(d+1,i);
	}
	//for (int d=0;d<DIM;d++) par[0] -= par[d+1]*M(d+1,i);
	cout << endl;
}

void CORE::compute_LBMAN_B(matrix &B, matrix &X, matrix &BB, matrix *dBMi, matrix *Xs)
{
	matrix I_A = I.sub(A); // pre-B:
	B = matrix(Q,Q);
	X = matrix(Q,Q);

	// allocate coefficients for the subtraction of conservative moments (rho, rho*u, rho*v, rho*w)
	ex **pars = new ex*[Q];
	for (int i=0;i<Q;i++)
		pars[i] = new ex[DIM+1];

	// central matrix
	for (int i=0;i<Q;i++) find_optimal_coefficients(I_A, pars[i], i);

	// do the magic
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
	{
		B(i,j) = I_A(i,j);
		for (int d=0;d<DIM+1;d++)
			B(i,j) += pars[i][d]*M(d,j);
	}
	X = I_A.sub(B);
	simplify_matrix(X);
	simplify_matrix(B);

//	cout << "|| I_A="<<I_A<<endl;
//	cout << "|| B="<<B<<endl;


	if (!constmatrixA && dBMi!=0)
	{
		for (int l=0;l<L;l++)
		{
			for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
			for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
			for (int x=-(l+1);x<=l+1;x++)
			if (isin(l,x,y,z))
			{
				matrix _A = As[index(l,x,y,z)];
				matrix _I_A = I.sub(_A);
				matrix _B = matrix(Q,Q);
				for (int i=0;i<Q;i++) find_optimal_coefficients(_I_A, pars[i], i);

				for (int i=0;i<Q;i++)
				for (int j=0;j<Q;j++)
				{
					_B(i,j) = _I_A(i,j);
					for (int d=0;d<DIM+1;d++) _B(i,j) += pars[i][d]*M(d,j);
				}
				Xs[index(l,x,y,z)] = _I_A.sub(_B);
				simplify_matrix(Xs[index(l,x,y,z)]);
				matrix dB = _B.sub(B);
				dBMi[index(l,x,y,z)] = dB.mul(Mi);
				simplify_matrix(dBMi[index(l,x,y,z)]);
			}
		}
	}

	// define symbolic matrices BB and AX here
	BB = matrix(Q,Q);
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
	{
		if (B(i,j)!=0)
		{
			BB(i,j) = symB[j+i*Q];
			// find duplicates among previously assigned BBs
			for (int i1=0;i1<=i;i1++)
			for (int j1=0;j1<Q;j1++)
			if (i1<i || (i1==i && j1<j))
			if (B(i1,j1)==B(i,j))
			{
				if (B(i1,j1)==B(i,j)) BB(i,j) = BB(i1,j1); // duplicate
			} else
			{
				// factors?
				if (B(i1,j1)!=0)
				{
					ex e = normal(B(i,j)/B(i1,j1));
					if (is_a<numeric>(e)) BB(i,j) = e*BB(i1,j1);
				}
			}
		} else BB(i,j) = 0;
	}

//	cout << "|| BB matrix=" << BB << endl;

	for (int i=0;i<Q;i++) delete [] pars[i];
	delete [] pars;
}

bool CORE::compute_LBMAN_matrices_symbolic_save_check()
{
	char fn[1000],dn[1000];
	for (int l=1;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z))
	{
		if (!mark_exists("%s/lbman_matrices_P/%02d/finished/%s_%03d_%03d_%03d", target_dir, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
			return false;
	}
	return true;
}

//#define NEWBB
void CORE::compute_LBMAN_matrices_SRT_save()
{
	matrix B,BB,X;
	compute_LBMAN_B(B, X, BB, 0, 0);
	// set matrix BB to numeric

	ex Bcoef = (ex)1-lbm.sym_o;
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
		BB(i,j)  = B(i,j)/Bcoef;

	INT_MATRIX iBB;
	iBB.allocate(Q,Q);
	iBB.empty();
	INT denominator = iBB.copy_ginac_matrix(BB);

	// allocate matrices
	INT_MATRIX*P = new INT_MATRIX[Nindex];
	ex *trP = new ex[Nindex];

	// STEP 02
	for (int z=-1;(z<=1 && DIM==3) || (z<=-1);z++)
	for (int y=-1;(y<=1 && DIM>=2) || (y<=-1);y++)
	for (int x=-1;x<=1;x++)
	{
		P[index(0,x,y,z)].allocate(Q,Q);
		P[index(0,x,y,z)].empty();
		trP[index(0,x,y,z)] = 0;
	}

	INT_MATRIX iE[Q];
	for (int q=0;q<Q;q++)
	{
		int i=CC[0][q];
		int j=(DIM>=2)? CC[1][q] : 0;
		int k=(DIM>=3)? CC[2][q] : 0;

		iE[q].allocate(Q,Q);
		iE[q].copy_ginac_matrix(E[q]);

		P[index(0,-i,-j,-k)].copy(iE[q]);
		P[index(0,-i,-j,-k)].mul(iBB);
	}

	// dry run
	int max=0,count=0;
	for (int l=1;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z)) max++;

	INT_MATRIX sumE;
	sumE.allocate(Q,Q);
	INT_MATRIX Aux;
	Aux.allocate(Q,Q);

	for (int l=1;l<L;l++)
	{
		if (verbosity==1) printf("||| compute LBMAN SRT matrices: level %d\n",l);
		// allocate required matrices
		int nz=0; // count non-zero matrices
		// sum_z, z \in M(l+1)_x, i.e., z = x - sum c_mi (i=0..l+1) ... but z = (x,y,z) here
		for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
		for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
		for (int x=-(l+1);x<=l+1;x++)
		if (isin(l,x,y,z))
		{
			count++;
			if (verbosity==1 && count % 100==0) { printf("|||| [%d/%d] 02    \r",count,max); fflush(stdout); }
			P[index(l,x,y,z)].allocate(Q,Q);
			P[index(l,x,y,z)].empty();
			// sum_y y\in M(l)_x
			for (int z1=-l;(z1<=l && DIM==3) || (z1<=-l);z1++)
			for (int y1=-l;(y1<=l && DIM>=2) || (y1<=-l);y1++)
			for (int x1=-l;x1<=l;x1++)
			if (isin(l-1,x1,y1,z1))
			{
				if (!P[index(l-1,x1,y1,z1)].is_zero_matrix())
				{
					sumE.empty();
					for (int q=0;q<Q;q++)
					{
						int i=CC[0][q];
						int j=(DIM>=2)? CC[1][q] : 0;
						int k=(DIM>=3)? CC[2][q] : 0;

						// P_{x-cq} = E_q  ... P_z = E_q  where x-cq=z
						if ( 	(DIM==1 && x1-i==x) ||
							(DIM==2 && x1-i==x && y1-j==y) ||
							(DIM==3 && x1-i==x && y1-j==y && z1-k==z)
						)
						sumE.add(iE[q]);
					}
					if (!sumE.is_zero_matrix())
					{
						Aux.mul(P[index(l-1,x1,y1,z1)], sumE);
						P[index(l,x,y,z)].add(Aux);
					}
				}
			}
			P[index(l,x,y,z)].mul(iBB);
			INT tr = P[index(l,x,y,z)].trace()/(l+1); // trace of P
			trP[index(l,x,y,z)] = ((ex)tr)*pow( Bcoef/denominator, l+1); //correction
			P[index(l,x,y,z)].sub_diagonal(tr);
			if (!P[index(l,x,y,z)].is_zero_matrix()) nz++;

		}
		if (verbosity==1) printf("|||| non-zero P matrices: %d\n",nz);
	}

	// export to file
	mkdir(target_dir,0777);
	char fn[1000], dn[1000];
	sprintf(dn,"%s/lbman_matrices_CP",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/lbman_matrices_trP",target_dir);
	mkdir(dn,0777);
	// create dir structure
	for (int l=0;l<=L;l++)
	{
		sprintf(dn,"%s/lbman_matrices_CP/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/lbman_matrices_trP/%02d",target_dir,l);
		mkdir(dn,0777);
	}

	// dry run
	if (verbosity==1) printf("||| compute CP matrices\n");
	max=0,count=0;
	for (int l=1;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z))
		max++;

	matrix CP=matrix(Q,Q);
	for (int l=0;l<L;l++)
	{
		for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
		for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
		for (int x=-(l+1);x<=l+1;x++)
		if (isin(l,x,y,z))
		{
			count++;
			if (verbosity==1 && count % 100==0)  { printf("|||| [%d/%d] CP and trP    \r",count++,max); fflush(stdout); }
			if (!P[index(l,x,y,z)].is_zero_matrix())
			{
				for (int i=0;i<Q;i++)
				for (int j=0;j<Q;j++)
				{
					CP(i,j)=0;
					for (int k=0;k<Q;k++) CP(i,j) += M(i,k)*(ex)(P[index(l,x,y,z)].d[k][j]);
					CP(i,j)*=pow(Bcoef/denominator,l+1);
				}
				if (!CP.is_zero_matrix()) save_matrix(CP, l+1, x, y, z, "CP", "_subs");
			}
		}
	}
	if (verbosity==1) printf("\n");

	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	{
		if (isin(l-1,x,y,z))
		if (trP[index(l-1,x,y,z)]!=0) save_trP(trP[index(l-1,x,y,z)], l-1, x, y, z, "_subs");
	}

	delete [] P;
	delete [] trP;
}

void CORE::compute_LBMAN_matrices_symbolic_save_parallel()
{
	matrix B,BB,X;
	compute_LBMAN_B(B, X, BB, 0, 0);

	if (!use_symbolic_matrices)
		BB = B;

	symtab table;
	if (use_symbolic_matrices)
	{
		for (int i=0;i<Q;i++)
		for (int j=0;j<Q;j++)
			table[symB[j+i*Q].get_name()] = symB[j+i*Q];
	} else
	{
		table[lbm.sym_o.get_name()] = lbm.sym_o;
		for (int i=0;i<3;i++) table[sym_vel[i].get_name()] = sym_vel[i];
		for (int i=0;i<MQ;i++) table[lbm.sym_os[i].get_name()] = lbm.sym_os[i];
	}
	parser reader(table);

	// allocate matrices
	matrix*P = new matrix[Nindex];

	// create dir structure
	mkdir(target_dir,0777);
	char dn[1000], dn2[1000], fn2[1000];
	sprintf(dn,"%s/lbman_matrices_P",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/lbman_matrices_CP",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/lbman_matrices_trP",target_dir);
	mkdir(dn,0777);
	// create dir structure
	for (int l=0;l<L;l++)
	{
		sprintf(dn,"%s/lbman_matrices_P/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/lbman_matrices_P/%02d/inprogress",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/lbman_matrices_P/%02d/finished",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/lbman_matrices_CP/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/lbman_matrices_trP/%02d",target_dir,l);
		mkdir(dn,0777);
	}
	// STEP 02
	for (int z=-1;(z<=1 && DIM==3) || (z<=-1);z++)
	for (int y=-1;(y<=1 && DIM>=2) || (y<=-1);y++)
	for (int x=-1;x<=1;x++)
	{
		P[index(0,x,y,z)] = matrix(Q,Q);
		empty_matrix(P[index(0,x,y,z)]);
	}

	for (int q=0;q<Q;q++)
	{
		int i=CC[0][q];
		int j=(DIM>=2)? CC[1][q] : 0;
		int k=(DIM>=3)? CC[2][q] : 0;
		P[index(0,-i,-j,-k)] = E[q].mul(BB);

		if (DIM<=2) k=1;
		if (DIM==1) j=1;
		matrix CPnew = M.mul(E[q]).mul(BB);
		simplify_matrix(CPnew);

		if (!mark("%s/lbman_matrices_P/%02d/inprogress/%s_%03d_%03d_%03d",target_dir, 0, "z",-i,(DIM>=2)?-j:0,(DIM>=3)?-k:0))
		if (!CPnew.is_zero_matrix()) save_matrix(CPnew, 1, -i, -j, -k, "CP", (use_symbolic_matrices) ? "" : "_subs");
	}

	// dry run
	int max=0,count=0;
	for (int l=1;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z))
		max++;

	matrix sumE=matrix(Q,Q);
	for (int l=1;l<L;l++)
	{
		// sum_z, z \in M(l+1)_x, i.e., z = x - sum c_mi (i=0..l+1) ... but z = (x,y,z) here
		for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
		for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
		for (int x=-(l+1);x<=l+1;x++)
		if (isin(l,x,y,z))
		{
			count++;
			if (verbosity==1 && count%10==0) { printf("|||| [%d/%d] level %d CP and trP symbolic          \r",count,max, l); fflush(stdout); }
			if (!mark("%s/lbman_matrices_P/%02d/inprogress/%s_%03d_%03d_%03d",target_dir, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
			{
				matrix Pnew = matrix(Q,Q);
				empty_matrix(Pnew);

				// sum_y y\in M(l)_x
				for (int z1=-l;(z1<=l && DIM==3) || (z1<=-l);z1++)
				for (int y1=-l;(y1<=l && DIM>=2) || (y1<=-l);y1++)
				for (int x1=-l;x1<=l;x1++)
				if (isin(l-1,x1,y1,z1))
				{
					matrix locP = matrix(Q,Q);
					empty_matrix(locP);

					if (l==1)
					{
						locP = P[index(l-1,x1,y1,z1)];
					} else
					{
						// load P from file
						sprintf(dn2,"%s/lbman_matrices_P/%02d",target_dir,l-1);
						sprintf(fn2,"%s/%s_%03d_%03d_%03d",dn2, "z",x1,(DIM>=2)?y1:0,(DIM>=3)?z1:0);
						if (file_exists(fn2))
						{
							ifstream gin(fn2);
							if (!gin.is_open()) cerr << "Error: " << strerror(errno);
							std::string line;
							// load matrix
							for (int i=0;i<Q;i++)
							for (int j=0;j<Q;j++)
							{
								getline( gin, line );
								locP(i,j) = (line.length()>0) ? reader(line) : 0;
							}
							gin.close();
						};
					}

					if (!locP.is_zero_matrix())
					{
						empty_matrix(sumE);
						for (int q=0;q<Q;q++)
						{
							int i=CC[0][q];
							int j=(DIM>=2)? CC[1][q] : 0;
							int k=(DIM>=3)? CC[2][q] : 0;

							// P_{x-cq} = E_q  ... P_z = E_q  where x-cq=z
							if ( 	(DIM==1 && x1-i==x) ||
								(DIM==2 && x1-i==x && y1-j==y) ||
								(DIM==3 && x1-i==x && y1-j==y && z1-k==z)
							)
							sumE = sumE.add(E[q]);
						}
						if (!sumE.is_zero_matrix()) Pnew = Pnew.add( locP.mul(sumE) );
					}
				}
				Pnew = Pnew.mul( BB );
				ex trPnew = expand(trace(Pnew)/(l+1));
				Pnew = Pnew.sub( I.mul_scalar(trPnew) );
				simplify_matrix(Pnew);
				// save
				matrix CPnew = M.mul(Pnew);
//				simplify_matrix(CPnew);

				if (!CPnew.is_zero_matrix()) save_matrix(CPnew, l+1, x, y, z, "CP", (use_symbolic_matrices) ? "" : "_subs");
				if (!Pnew.is_zero_matrix()) save_matrix(Pnew, l, x, y, z, "P", "");
				if (trPnew!=0) save_trP(trPnew, l, x, y, z, (use_symbolic_matrices) ? "" : "_subs");
				// create finish mark
				create_mark("%s/lbman_matrices_P/%02d/finished/%s_%03d_%03d_%03d",target_dir, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0);
			}
		}
		// synchronize: wait for all computations to finish
		bool all=false;
		while (!all)
		{
			all=true;
			// check whether everything is computed on the given time level
			for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
			for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
			for (int x=-(l+1);x<=l+1;x++)
			if (isin(l,x,y,z))
				if (!mark_exists("%s/lbman_matrices_P/%02d/finished/%s_%03d_%03d_%03d",target_dir, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0)) all=false;
			if (!all) sleep(5);
		}
	}
	delete [] P;
}

void CORE::compute_LBMAN_matrices_symbolic_load(matrix*CP, ex*trP)
{
	matrix B,BB,X;
	compute_LBMAN_B(B, X, BB, 0, 0);
	// prepare table
	symtab table;
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
		table[symB[j+i*Q].get_name()] = symB[j+i*Q];
	parser reader(table);

	char fn[1000], dn[1000];

	CP[index(0,0,0,0)] = M;
	trP[index(0,0,0,0)] = 0;

	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	{
		if (isin(l,x,y,z))
		{
			CP[index(l,x,y,z)] = matrix(Q,Q);
			load_CP(CP[index(l,x,y,z)], l, x, y, z, "", reader);
		}
		if (isin(l-1,x,y,z)) trP[index(l-1,x,y,z)] = load_trP(l-1,x,y,z, "", reader);
	}
}

void CORE::compute_LBMAN_matrices_load(matrix*CP, ex*trP)
{
	matrix B,BB,X;
	compute_LBMAN_B(B, X, BB, 0, 0);

	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);

	char fn[1000], dn[1000];

	CP[index(0,0,0,0)] = M;
	trP[index(0,0,0,0)] = 0;

	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	{
		if (isin(l,x,y,z))
		{
			CP[index(l,x,y,z)] = matrix(Q,Q);
			load_CP(CP[index(l,x,y,z)], l, x, y, z, "_subs", reader);
		}
		if (isin(l-1,x,y,z)) trP[index(l-1,x,y,z)] = load_trP(l-1, x, y, z, "_subs", reader);
	}
}

bool CORE::compute_LBMAN_matrices_symbolic_load_simplify_and_save_check()
{
	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	{
		if (isin(l,x,y,z))
		if (!mark_exists("%s/lbman_matrices_CP/finished/%02d_%s_%03d_%03d_%03d",target_dir, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
			return false;
		if (isin(l-1,x,y,z))
		if (!mark_exists("%s/lbman_matrices_trP/finished/%02d_%s_%03d_%03d_%03d", target_dir, l-1, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
			return false;
	}
	return true;
}

void CORE::compute_LBMAN_matrices_symbolic_load_simplify_and_save()
{
	matrix B,BB,X;
	compute_LBMAN_B(B, X, BB, 0, 0);
	// prepare table
	symtab table;
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
		if (BB(i,j) == symB[j+i*Q]) table[symB[j+i*Q].get_name()] = B(i,j);
	parser reader(table);

	char dn[1000], dn_mark[1000], dn_finish[1000];

	// dry run
	int max=0;
	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	if (isin(l,x,y,z)) max++;

	sprintf(dn,"%s/lbman_matrices_CP",target_dir);
	mkdir(dn,0777);
	sprintf(dn_mark,"%s/inprogress",dn);
	mkdir(dn_mark,0777);
	sprintf(dn_finish,"%s/finished",dn);
	mkdir(dn_finish,0777);
	// work on CPs
	int count=0;
	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	if (isin(l,x,y,z))
	{
		count++;
		if (!mark("%s/%02d_%s_%03d_%03d_%03d",dn_mark, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
		{
			if (verbosity>=1 && count%100==0) {  printf("|||| [ %d / %d ] CP subs     \r",count,max); fflush(stdout);} 
			matrix CP = matrix(Q,Q);
			load_CP(CP, l, x, y, z,"", reader);
			simplify_matrix(CP);
			if (!CP.is_zero_matrix())
			{
				save_matrix(CP, l, x, y, z, "CP", "_subs");
			}
			create_mark("%s/%02d_%s_%03d_%03d_%03d",dn_finish, l, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0);
		}
	}

	// dry run
	max=0;
	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	if (isin(l-1,x,y,z))
		 max++;

	sprintf(dn,"%s/lbman_matrices_trP",target_dir);
	mkdir(dn,0777);
	sprintf(dn_mark,"%s/inprogress",dn);
	mkdir(dn_mark,0777);
	sprintf(dn_finish,"%s/finished",dn);
	mkdir(dn_finish,0777);
	// work on trPs
	count=0;
	for (int l=1;l<=L;l++)
	for (int z=-l;(z<=l && DIM==3) || (z<=-l);z++)
	for (int y=-l;(y<=l && DIM>=2) || (y<=-l);y++)
	for (int x=-l;x<=l;x++)
	if (isin(l-1,x,y,z))
	{
		count++;
		if (!mark("%s/%02d_%s_%03d_%03d_%03d",dn_mark, l-1, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0))
		{
			if (verbosity>=1 && count%100==0) {  printf("|||| [ %d / %d ] trP subs     \r",count,max); fflush(stdout);} 
			ex trP = load_trP(l-1, x, y, z, "", reader);
			if (trP!=0)
			{
				trP = expand(trP);
				save_trP(trP, l-1, x, y, z, "_subs");
			}
			create_mark("%s/%02d_%s_%03d_%03d_%03d",dn_finish, l-1, "z",x,(DIM>=2)?y:0,(DIM>=3)?z:0);
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////
//
// STEP 02: compute EFDE coefficients
//
////////////////////////////////////////////////////////////////////////////////////////////

void CORE::load_EFDE_coefs(matrix &coefs, int pde, int l, int i1, int i2, int i3, const char *desc, parser &reader, bool do_subs=true)
{
	if (use_NSE_strategies)
	load_optimal_pars();

	char dn[1000],fn[1000];
	sprintf(dn,"%s/%s/%02d",target_dir,desc,l);
	sprintf(fn,"%s/%03d_%03d_%03d_subs", dn, i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0);
	if (file_exists(fn))
	{
		ifstream gin(fn);
		if (!gin.is_open()) cerr << "Error: " << strerror(errno);
		std::string line; 
		for (int q1=0;q1<Q;q1++)
		for (int q2=0;q2<Q;q2++)
		{
			getline( gin, line );
			coefs(q1,q2) = (line.length()>0) ? reader(line) : 0;
			if (do_subs && use_NSE_strategies) coefs(q1,q2) = expand( subs( coefs(q1,q2), optimal_pars[pde] ) );
		}
		gin.close();
	} else  empty_matrix(coefs);
}

// loads CP matrix from file
void CORE::load_CP(matrix &CP, int l, int i1, int i2, int i3, const char *desc, parser &reader)
{
	if (l==0 && i1==0 && i2==0 && i3==0)
	{
		CP=M;
		return;
	}
	char fn[1000], dn[1000];
	empty_matrix(CP);

	sprintf(dn,"%s/lbman_matrices_CP/%02d",target_dir,l);
	sprintf(fn,"%s/%s_%03d_%03d_%03d%s",dn, "z",i1,(DIM>=2)?i2:0,(DIM>=3)?i3:0, desc);
	if (isin(l,i1,i2,i3))
	{
		if (file_exists(fn))
		{
			ifstream gin(fn);
			if (!gin.is_open()) cerr << "Error: " << strerror(errno);
			std::string line; 
			for (int i=0;i<Q;i++)
			for (int j=0;j<Q;j++)
			{
				getline( gin, line );
				if (line.length()>0) CP(i,j) = reader(line);
			}
			gin.close();
		}
	}
}

void CORE::save_matrix(matrix &CP, int l, int i1, int i2, int i3, const char*name, const char *desc)
{
	char dn[1000],fn_symlink[1000], fn_pid[1000], fn[1000];
	sprintf(dn,"%s/lbman_matrices_%s/%02d",target_dir,name,l);
	sprintf(fn,"%s_%03d_%03d_%03d%s", "z",i1,(DIM>=2)?i2:0,(DIM>=3)?i3:0,desc);
	sprintf(fn_symlink,"%s/%s",dn,fn);
	sprintf(fn_pid,"%s/%s___%d",dn, fn, getpid());
	ofstream gout(fn_pid);
	for (int i=0;i<Q;i++)
	for (int j=0;j<Q;j++)
	if (CP(i,j)!=0)
		gout << CP(i,j) << endl;
	else
		gout << endl;

	gout.close();
	// link it!
	sprintf(fn_pid,"%s___%d",fn, getpid());
	symlink(fn_pid, fn_symlink);
}


ex CORE::load_trP(int l, int i1, int i2, int i3, const char *desc, parser &reader)
{
	if (l==0 && i1==0 && i2==0 && i3==0) return 0;
	char fn[1000], dn[1000];

	sprintf(dn,"%s/lbman_matrices_trP/%02d",target_dir,l);
	sprintf(fn,"%s/%s_%03d_%03d_%03d%s",dn, "z", i1,(DIM>=2)?i2:0,(DIM>=3)?i3:0, desc);
	if (isin(l,i1,i2,i3))
	{
		if (file_exists(fn))
		{
			ifstream gin(fn);
			if (!gin.is_open()) cerr << "Error: " << strerror(errno);
			ex trP = reader(gin);
			gin.close();
			return trP;
		} else return 0;
	}
	return 0;
}

void CORE::save_trP(ex trP, int l, int i1, int i2, int i3, const char *desc="_subs")
{
	char dn[1000], fn[1000], fn_pid[1000], fn_symlink[1000];;
	sprintf(dn,"%s/lbman_matrices_trP/%02d",target_dir,l);
	sprintf(fn,"%s_%03d_%03d_%03d%s", "z", i1,(DIM>=2)?i2:0,(DIM>=3)?i3:0,desc);
	sprintf(fn_symlink,"%s/%s",dn,fn);
	sprintf(fn_pid,"%s/%s___%d",dn, fn, getpid());
	ofstream gout(fn_pid);
	gout << trP << endl;
	gout.close();
	// link it!
	sprintf(fn_pid,"%s___%d",fn, getpid());
	symlink(fn_pid, fn_symlink);
}

bool CORE::compute_EFDE_parts_save_parallel_check()
{
	for (int l=0;l<L;l++)
	for (int i3=-l;(i3<=l && DIM==3) || (i3<=-l);i3++)
	for (int i2=-l;(i2<=l && DIM>=2) || (i2<=-l);i2++)
	for (int i1=-l;i1<=l;i1++)
	if (isin(l,i1,i2,i3))
	{
		if (!mark_exists("%s/efde_coefs_parts/%02d/finished/%s_%03d_%03d_%03d",target_dir, l, "z", i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0))
			return false;
	}
	return true;
}

void CORE::compute_EFDE_parts_save_parallel()
{
	mkdir(target_dir,0777);

	// allocate matrices
	matrix *dBMi = new matrix[Nindex];
	matrix *Xs = new matrix[Nindex];
	// constant matrix B
	matrix B,X,BB;
	compute_LBMAN_B(B, X, BB, dBMi, Xs);

	// dry run
	int max=0,count=0;
	for (int l=0;l<L;l++)
	for (int i3=-l;(i3<=l && DIM==3) || (i3<=-l);i3++)
	for (int i2=-l;(i2<=l && DIM>=2) || (i2<=-l);i2++)
	for (int i1=-l;i1<=l;i1++)
	if (isin(l,i1,i2,i3))
		max++;

	char  dn[1000], dd[1000], fn[1000], dneq[1000];
	mkdir(target_dir,0777);
	sprintf(dn,"%s/efde_coefs_parts",target_dir);
	mkdir(dn,0777);
	sprintf(dneq,"%s/efde_coefs_parts_eq",target_dir);
	mkdir(dneq,0777);
	// create dir structure
	for (int l=0;l<L;l++)
	{
		sprintf(dn,"%s/efde_coefs_parts/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs_parts_eq/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs_parts/%02d/inprogress",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs_parts/%02d/finished",target_dir,l);
		mkdir(dn,0777);
	}
	// prepare pareser for load_CP
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);

	matrix CP=matrix(Q,Q);
	matrix coefs=matrix(Q,Q), coefs_eq=matrix(Q,Q);
	matrix locA;
	matrix out, term;

	for (int l=0;l<L;l++)
	for (int i3=-l;(i3<=l && DIM==3) || (i3<=-l);i3++)
	for (int i2=-l;(i2<=l && DIM>=2) || (i2<=-l);i2++)
	for (int i1=-l;i1<=l;i1++)
	if (isin(l,i1,i2,i3))
	{
		count++;
		if (!mark("%s/efde_coefs_parts/%02d/inprogress/%s_%03d_%03d_%03d", target_dir, l, "z", i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0))
		{
			load_CP(CP,l,i1,i2,i3,"_subs",reader);
			if (verbosity==1 && count%100==0) { printf("|||| [%d/%d] EFDE coefs parts    \r",count,max); fflush(stdout); }
			if (!CP.is_zero_matrix())
			for (int q=0;q<Q;q++)
			{
				empty_matrix(coefs);
				empty_matrix(coefs_eq);
				int k1=CC[0][q];
				int k2=(DIM>=2) ? CC[1][q] : 0;
				int k3=(DIM>=3) ? CC[2][q] : 0;
				int i1k1=i1-k1;
				int i2k2=i2-k2;
				int i3k3=i3-k3;

				locA = (constmatrixA) ? A.add(X) : As[index(l,i1k1,i2k2,i3k3)].add(Xs[index(l,i1k1,i2k2,i3k3)]);

				out = CP.mul(E[q]).mul(locA).mul(Mi);
				for (int q1=0;q1<Q;q1++)
				for (int q2=0;q2<Q;q2++)
					coefs_eq(q1,q2) += (out(q1,q2));
				// fill vecm
				if (!constmatrixA) // CLBM B = B_0 + Delta B ... dB ... dB.Mi
				{
					out = CP.mul(E[q]).mul(dBMi[index(l,i1k1,i2k2,i3k3)]);
					for (int q1=0;q1<Q;q1++)
					for (int q2=0;q2<Q;q2++)
						coefs(q1,q2) += out(q1,q2);
				}
				// save this contribution
				if (!coefs.is_zero_matrix())
				{
					sprintf(dn,"%s/efde_coefs_parts/%02d/%03d_%03d_%03d",target_dir,l, i1k1, (DIM>=2) ? i2k2 : 0, (DIM>=3) ? i3k3 : 0);
					mkdir(dn,0777);
					sprintf(fn,"%s/ctrb_%s_%03d_%03d_%03d", dn, "z", i1, i2, i3);
					ofstream gout(fn);
					for (int q1=0;q1<Q;q1++)
					for (int q2=0;q2<Q;q2++)
					if (coefs(q1,q2)!=0)
						gout << coefs(q1,q2) << endl;
					else
						gout << endl;
					gout.close();
				}
				if (!coefs_eq.is_zero_matrix())
				{
					sprintf(dn,"%s/efde_coefs_parts_eq/%02d/%03d_%03d_%03d",target_dir,l, i1k1, (DIM>=2) ? i2k2 : 0, (DIM>=3) ? i3k3 : 0);
					mkdir(dn,0777);
					sprintf(fn,"%s/ctrb_%s_%03d_%03d_%03d", dn, "z", i1, i2, i3);

					ofstream gout(fn);
					for (int q1=0;q1<Q;q1++)
					for (int q2=0;q2<Q;q2++)
					if (coefs_eq(q1,q2)!=0)
						gout << coefs_eq(q1,q2) << endl;
					else
						gout << endl;
					gout.close();
				}
			}
			// mark finished
			create_mark("%s/efde_coefs_parts/%02d/finished/%s_%03d_%03d_%03d", target_dir, l, "z", i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0);
		}
	}
}

bool CORE::compute_EFDE_coefs_save_parallel_check()
{
	for (int l=0;l<L;l++)
	for (int i3=-(l+1);(i3<=(l+1) && DIM==3) || (i3<=-(l+1));i3++)
	for (int i2=-(l+1);(i2<=(l+1) && DIM>=2) || (i2<=-(l+1));i2++)
	for (int i1=-(l+1);i1<=(l+1);i1++)
	if (isin(l,i1,i2,i3))
	if (!mark_exists("%s/efde_coefs/%02d/finished/%03d_%03d_%03d",target_dir, l, i1, (DIM>=2) ? i2 : 0, (DIM==3) ? i3 : 0))
		return false;
	return true;
}

void CORE::compute_EFDE_coefs_save_parallel()
{
	mkdir(target_dir,0777);
	char fn[1000], dn[1000];
	// prepare pareser for load_CP
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);

	mkdir(target_dir,0777);
	sprintf(dn,"%s/efde_coefs",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/efde_coefs_eq",target_dir);
	mkdir(dn,0777);
	for (int l=0;l<L;l++)
	{
		sprintf(dn,"%s/efde_coefs/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs_eq/%02d",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs/%02d/inprogress",target_dir,l);
		mkdir(dn,0777);
		sprintf(dn,"%s/efde_coefs/%02d/finished",target_dir,l);
		mkdir(dn,0777);
	}

	// dry run and erase coefs_ arrays
	int max=0,count=0;
	for (int l=0;l<L;l++)
	for (int i3=-(l+1);(i3<=(l+1) && DIM==3) || (i3<=-(l+1));i3++)
	for (int i2=-(l+1);(i2<=(l+1) && DIM>=2) || (i2<=-(l+1));i2++)
	for (int i1=-(l+1);i1<=(l+1);i1++)
	if (isin(l,i1,i2,i3))
		max++;

	matrix coefs=matrix(Q,Q);
	matrix coefs_eq=matrix(Q,Q);
	count=0;
	for (int l=0;l<L;l++)
	for (int i3=-(l+1);(i3<=(l+1) && DIM==3) || (i3<=-(l+1));i3++)
	for (int i2=-(l+1);(i2<=(l+1) && DIM>=2) || (i2<=-(l+1));i2++)
	for (int i1=-(l+1);i1<=(l+1);i1++)
	if (isin(l,i1,i2,i3))
	{
		count++;
		if (!mark("%s/efde_coefs/%02d/inprogress/%03d_%03d_%03d",target_dir, l, i1, (DIM>=2) ? i2 : 0, (DIM==3) ? i3 : 0))
		{
			if (verbosity==1 && count%10==0) { printf("|||| [%d/%d] EFDE coefs combine & simplify    \r",count,max); fflush(stdout); }
			empty_matrix(coefs);
			empty_matrix(coefs_eq);
			// load contributions
			sprintf(dn,"%s/efde_coefs_parts/%02d/%03d_%03d_%03d",target_dir, l, i1, (DIM>=2) ? i2 : 0, (DIM==3) ? i3 : 0);
			struct dirent *de;
			DIR *dr = opendir(dn);
			if (dr!=NULL)
			{
				while ((de = readdir(dr)) != NULL)
				{
					if (strstr(de->d_name, "ctrb")!=NULL)
					{
						sprintf(fn,"%s/%s",dn,de->d_name);
						ifstream gin(fn);
						if (!gin.is_open()) cerr << "Error: " << strerror(errno);
						std::string line;
						for (int i=0;i<Q;i++)
						for (int j=0;j<Q;j++)
						{
							getline( gin, line );
							if (line.length()>0) coefs(i,j) += reader(line);
						}
						gin.close();
					}
				}
			}
			closedir(dr);
			// load eq contributions
			sprintf(dn,"%s/efde_coefs_parts_eq/%02d/%03d_%03d_%03d",target_dir, l, i1, (DIM>=2) ? i2 : 0, (DIM==3) ? i3 : 0);
			dr = opendir(dn);
			if (dr!=NULL)
			{
				while ((de = readdir(dr)) != NULL)
				{
					if (strstr(de->d_name, "ctrb")!=NULL)
					{
						sprintf(fn,"%s/%s",dn,de->d_name);
						ifstream gin(fn);
						if (!gin.is_open()) cerr << "Error: " << strerror(errno);
						std::string line;
						for (int i=0;i<Q;i++)
						for (int j=0;j<Q;j++)
						{
							getline( gin, line );
							if (line.length()>0) coefs_eq(i,j) += reader(line);
						}
						gin.close();
					}
				}
			}
			closedir(dr);

			// add trace
			ex trPz = load_trP(l,i1,i2,i3,"_subs",reader);
			for (int q1=0;q1<Q;q1++)
			{
				if (pde_strategy==ADE)
				{
					if (q1==0) // coefs_eq == coefs for that
						coefs_eq(q1,q1) += trPz;
					else
						coefs(q1,q1) += trPz;
				}
				else
				{
					if (q1<DIM+1) // coefs_eq == coefs for that
						coefs_eq(q1,q1) += trPz;
					else
						coefs(q1,q1) += trPz;
				}
			}
			// save
			if (!coefs.is_zero_matrix())
			{
				sprintf(dn,"%s/efde_coefs/%02d",target_dir,l);
				sprintf(fn,"%s/%03d_%03d_%03d_subs", dn, i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0);
				simplify_matrix(coefs);
				ofstream gout(fn);
				for (int i=0;i<Q;i++)
				for (int j=0;j<Q;j++)
				if (coefs(i,j)!=0)
					gout << expand(coefs(i,j)) << endl;
				else
					gout << endl;
				gout.close();
			}
			if (!coefs_eq.is_zero_matrix())
			{
				sprintf(dn,"%s/efde_coefs_eq/%02d",target_dir,l);
				sprintf(fn,"%s/%03d_%03d_%03d_subs", dn, i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0);
				simplify_matrix(coefs_eq);
				ofstream gout(fn);
				for (int i=0;i<Q;i++)
				for (int j=0;j<Q;j++)
				if (coefs_eq(i,j)!=0)
					gout << expand(coefs_eq(i,j)) << endl;
				else
					gout << endl;
				gout.close();
			}
			// finished
			create_mark("%s/efde_coefs/%02d/finished/%03d_%03d_%03d",target_dir, l, i1, (DIM>=2) ? i2 : 0, (DIM==3) ? i3 : 0);
		}
	}
}

void CORE::export_EFDE_coefs(int fde)
{
	int last_L_nonzero=0;

	// EFDE load table
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);
	matrix efde_coefs=matrix(Q,Q);

	mkdir(target_dir,0777);
	char fn[100];
	sprintf(fn,"%s/efde%d.tex",target_dir,fde);

	if (verbosity==1) { printf("||| export_EFDE_coefs: %s\n", fn); fflush(stdout); }
	ofstream gout(fn);
	gout << latex;
	gout<< "\\begin{flushleft}" << endl;
	gout<< "\\noindent $"<<endl;

	// dry run
	int max=0;
	for (int l=0;l<L;l++)
	for (int i3=-l-1;(i3<=l+1 && DIM==3) || (i3<=-l-1);i3++)
	for (int i2=-l-1;(i2<=l+1 && DIM>=2) || (i2<=-l-1);i2++)
	for (int i1=-l-1;i1<=l+1;i1++)
	if (isin(l,i1,i2,i3))
		max++;


	// moment
	gout<<"{\\color{blue}";
	if (pde_strategy==NSE && fde < DIM+1)
		gout << "\\mu^{eq,t+\\dt}_{"<<fde+1<<",x";
	else
		gout << "\\mu^{t+\\dt}_{"<<fde+1<<",x";
	if (DIM>=2) gout <<",y";
	if (DIM>=3) gout <<",z";
	gout << "}}=\n";

	bool first=true;
	int count=0;
	for (int l=0;l<L;l++)
	{
		for (int i3=-l-1;(i3<=l+1 && DIM==3) || (i3<=-l-1);i3++)
		for (int i2=-l-1;(i2<=l+1 && DIM>=2) || (i2<=-l-1);i2++)
		for (int i1=-l-1;i1<=l+1;i1++)
		if (isin(l,i1,i2,i3))
		{
			count++;
			if (verbosity==1 && count%100==0) { printf("|||| [%d/%d] export EFDE coefs \r",count,max); fflush(stdout); }
			load_EFDE_coefs(efde_coefs, fde, l, i1, i2, i3, "efde_coefs", reader);
			for (int q=0;q<Q;q++)
			{
				char s_space_coeff[100], s_time_coeff[100], s_space_formula[100], s_time_formula[100], str[1024];
				desc2str(s_space_coeff, s_time_coeff, s_space_formula, s_time_formula, l, i1, i2, i3);

				ex c = efde_coefs(fde,q);
				if (c!=0)
				{
					if (first) first=false; else gout<<" + \n";
					// coef
					if (c!=1) gout << factorize_latex(c);
					// moment
					gout<<"{\\color{blue}\\mu^{"<<s_time_coeff<<"}_{"<<q+1<<","<<s_space_formula<<"}}\n";
				}
			}
			// equilibrium
			load_EFDE_coefs(efde_coefs, fde, l, i1, i2, i3, "efde_coefs_eq", reader);
			for (int q=0;q<Q;q++)
			{
				char s_space_coeff[100], s_time_coeff[100], s_space_formula[100], s_time_formula[100], str[1024];
				desc2str(s_space_coeff, s_time_coeff, s_space_formula, s_time_formula, l, i1, i2, i3);

				ex c = efde_coefs(fde,q);
				if (c!=0)
				{
					if (first) first=false; else gout<<" + \n";
					// coef
					if (c!=1) gout << factorize_latex(c);
					// moment
					gout<<"{\\color{blue}\\mu^{eq,"<<s_time_coeff<<"}_{"<<q+1<<","<<s_space_formula<<"}}\n";
				}
			}
		}
	}

	gout << "$\n\\end{flushleft}\n";
	gout.close();
	cout << dflt;
}

////////////////////////////////////////////////////////////////////////////////////////////
//
// STEP 03: compute EPDE coefficients
//
////////////////////////////////////////////////////////////////////////////////////////////

void CORE::load_EPDE_coefs(matrix &coefs, int i0, int i1, int i2, int i3, const char *desc, parser &reader)
{
	char dn[1000],fn[1000];
	sprintf(dn,"%s/%s",target_dir,desc);
	sprintf(fn,"%s/%02d_%02d_%02d_%02d", dn, i0, i1, (DIM>=2)?i2:0, (DIM>=3)?i3:0);
	if (file_exists(fn))
	{
		ifstream gin(fn);
		if (!gin.is_open()) cerr << "Error: " << strerror(errno);
		std::string line;
		for (int q1=0;q1<Q;q1++)
		for (int q2=0;q2<Q;q2++)
		{
			getline( gin, line );
			coefs(q1,q2) = (line.length()>0) ? reader(line) : 0;
		}
		gin.close();
	} else  empty_matrix(coefs);
}

void CORE::compute_EPDE_coefs_and_save()
{
	// prepare table for EFDE coefs load
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);
	matrix efde_coefs=matrix(Q,Q), efde_coefs_eq=matrix(Q,Q);
	matrix ce=matrix(Q,Q), ce_eq=matrix(Q,Q);

	// prepare dir tree
	mkdir(target_dir,0777);
	char fn[1000], dn[1000], fn_mark[1000], fn_eq[1000];

	mkdir(target_dir,0777);
	sprintf(dn,"%s/epde_coefs",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/epde_coefs_eq",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/epde_coefs/inprogress",target_dir);
	mkdir(dn,0777);
	sprintf(dn,"%s/epde_coefs/finished",target_dir);
	mkdir(dn,0777);

	// dry run
	int max=0;
	for (int k=0;k<=ORDER;k++)
	for (int j0=0;j0<=k;j0++)
	for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
	for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
	for (int j1=0;j1<=k;j1++)
	if (j0+j1+j2+j3==k)
		max++;

	int count=0;
	for (int k=0;k<=ORDER;k++)
	for (int j0=0;j0<=k;j0++)
	for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
	for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
	for (int j1=0;j1<=k;j1++)
	if (j0+j1+j2+j3==k)
	{
		if (verbosity==1) { printf("|||| [ %d / %d ] EPDE coefs: compute and save    \r",count++,max); fflush(stdout); }
		if (!mark("%s/epde_coefs/inprogress/%02d_%02d_%02d_%02d",target_dir, j0, j1, j2, j3))
		{
			ex glkoef = (ex)1;
			if (j0>0) glkoef /= factorial(j0);
			if (j1>0) glkoef /= factorial(j1);
			if (j2>0) glkoef /= factorial(j2);
			if (j3>0) glkoef /= factorial(j3);


			empty_matrix(ce);
			empty_matrix(ce_eq);

			for (int l=0;l<L;l++)
			for (int i3=-l-1;(i3<=l+1 && DIM==3) || (i3<=-l-1);i3++)
			for (int i2=-l-1;(i2<=l+1 && DIM>=2) || (i2<=-l-1);i2++)
			for (int i1=-l-1;i1<=l+1;i1++)
			if (isin(l,i1,i2,i3))
			{

				ex koef = (ex)1;
				if (j0>0) koef *= (l==0) ? 0 : pow(-l*dt,j0);
				if (j1>0) koef *= (i1==0) ? 0 : pow(i1*dl,j1);
				if (j2>0) koef *= (i2==0) ? 0 : pow(i2*dl,j2);
				if (j3>0) koef *= (i3==0) ? 0 : pow(i3*dl,j3);

				int maxq2=(pde_strategy==ADE) ?  maxq2=1 : DIM+1; // NSE/ADE selector
				if (koef!=0)
				for (int q1=0;q1<Q;q1++)
				{
					load_EFDE_coefs(efde_coefs, q1, l, i1, i2, i3, "efde_coefs", reader);
					load_EFDE_coefs(efde_coefs_eq, q1, l, i1, i2, i3, "efde_coefs_eq", reader);
					for (int q2=0;q2<Q;q2++)
					{
						if (q2<maxq2)
						{
							ce(q1,q2) += efde_coefs(q1,q2)*koef;
							ce(q1,q2) += efde_coefs_eq(q1,q2)*koef;
						}
						else
						{
							ce(q1,q2) += efde_coefs(q1,q2)*koef;
							ce_eq(q1,q2) += efde_coefs_eq(q1,q2)*koef;
						}
					}
				}
			}
			// compensate for LHS Taylor expansion
			if (j1+j2+j3==0)
			for (int q1=0;q1<Q;q1++)
				ce(q1,q1) -= (ex)1*pow(dt, j0);

			for (int q1=0;q1<Q;q1++)
			for (int q2=0;q2<Q;q2++)
			{
				ce(q1,q2) *= glkoef;
				ce_eq(q1,q2) *= glkoef;
			}

			simplify_matrix(ce);
			simplify_matrix(ce_eq);
			// save
			sprintf(fn,"%s/epde_coefs/%02d_%02d_%02d_%02d",target_dir, j0, j1, j2, j3);
			ofstream gout(fn);
			for (int q1=0;q1<Q;q1++)
			for (int q2=0;q2<Q;q2++)
			if (ce(q1,q2)!=0)
				gout << ce(q1,q2) << endl;
			else
				gout << 0 << endl;
			gout.close();
			sprintf(fn_eq,"%s/epde_coefs_eq/%02d_%02d_%02d_%02d",target_dir, j0, j1, j2, j3);
			ofstream gout_eq(fn_eq);
			for (int q1=0;q1<Q;q1++)
			for (int q2=0;q2<Q;q2++)
			if (ce_eq(q1,q2)!=0)
				gout_eq << ce_eq(q1,q2) << endl;
			else
				gout_eq << 0 << endl;
			gout_eq.close();
			// finished!
			create_mark("%s/epde_coefs/finished/%02d_%02d_%02d_%02d",target_dir, j0, j1, j2, j3);
		}
	}
}

bool CORE::compute_EPDE_coefs_and_save_check()
{
	for (int k=0;k<=ORDER;k++)
	for (int j0=0;j0<=k;j0++)
	for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
	for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
	for (int j1=0;j1<=k;j1++)
	if (j0+j1+j2+j3==k)
		if (!mark_exists("%s/epde_coefs/finished/%02d_%02d_%02d_%02d",target_dir, j0, j1, j2, j3)) return false;
	return true;
}

// reconstruct PDEs
void CORE::export_EPDE_coefs(int q_pde)
{
	symtab table;
	prepare_EFDE_load_table(table);
	parser reader(table);
	matrix epde_coefs=matrix(Q,Q), epde_coefs_eq=matrix(Q,Q);

	// prepare subs lists
	lst list_vels, list_vels_functions;
	allocate_Taylor();
	if (use_tay_vels)
	{
		taylor_list_vels(list_vels);
		taylor_list_vels_functions(list_vels_functions);
	}

	vct bas;
	for (int q=0;q<Q;q++) bas.push_back( f_mu[q] );
	for (int q=0;q<Q;q++) bas.push_back( f_mueq[q] );
	for (int d=0;d<DIM;d++) bas.push_back( f_vel[d] );

	PDE_STRUCT2 pde;
	pde.allocate(bas, ORDER, t, x, y, z);


	// dry run
	int max=0;
	for (int k=0;k<=ORDER;k++)
	for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
	for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
	for (int j1=0;j1<=k;j1++)
	for (int j0=0;j0<=k;j0++)
	if (j0+j1+j2+j3==k)
		max++;

	// reconstruct complete pde
	int count=0;
	for (int k=0;k<=ORDER;k++)
	for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
	for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
	for (int j1=0;j1<=k;j1++)
	for (int j0=0;j0<=k;j0++)
	if (j0+j1+j2+j3==k)
	{
		count++;
		if (verbosity) { printf("||| [ %d / %d ] preparing PDE %d \r", count, max, q_pde); fflush(stdout); }
		load_EPDE_coefs(epde_coefs, j0, j1, j2, j3, "epde_coefs", reader);
		load_EPDE_coefs(epde_coefs_eq, j0, j1, j2, j3, "epde_coefs_eq", reader);

		for (int q=0;q<Q;q++)
		{
			ex e;
			e = epde_coefs(q_pde, q);
			if (use_tay_vels)
			{
				e = expand(subs(expand( e ), list_vels));
				e = expand(subs(expand( e ), list_vels_functions));
			}
			pde.eat( e* diff(diff(diff(diff( f_mu[q], t, j0), x, j1), y, j2), z, j3) );

			e = epde_coefs_eq(q_pde, q);
			if (use_tay_vels)
			{
				e = expand(subs(expand( e ), list_vels));
				e = expand(subs(expand( e ), list_vels_functions));
			}
			pde.eat( e*diff(diff(diff(diff( f_mueq[q], t, j0), x, j1), y, j2), z, j3) );
		}
	}


	cout << "|| PDE "<<q_pde<< " saving" << endl << endl;
	pde.subs_vels = subs_vels;
	pde.save_tex(target_dir, "epde_coefs_tex","raw_pde_%02d_order_%d",q_pde,ORDER);

	// divide by the factor
	ex dmdt = pde.data(q_pde,1,0,0,0);
	if (dmdt!=0) pde.mul((ex)1/dmdt);
	pde.normal();
	pde.save_tex(target_dir, "epde_coefs_tex","pde_%02d_order_%d",q_pde,ORDER);
	pde.save(target_dir, "epde_coefs_maxima","pde_%02d_order_%d",q_pde,ORDER);
}

CORE::CORE(int iDIM, int iQ) : DEF(iDIM, iQ)
{
	sprintf(target_dir,"default");
	// prepare VEC
	f_rho = frho(t,x,y,z);
	f_vel[0]=fu(t,x,y,z);
	f_vel[1]=fv(t,x,y,z);
	f_vel[2]=fw(t,x,y,z);

	f_mu.push_back(fmu0(t,x,y,z));
	f_mu.push_back(fmu1(t,x,y,z));
	f_mu.push_back(fmu2(t,x,y,z));
	f_mu.push_back(fmu3(t,x,y,z));
	f_mu.push_back(fmu4(t,x,y,z));
	f_mu.push_back(fmu5(t,x,y,z));
	f_mu.push_back(fmu6(t,x,y,z));
	f_mu.push_back(fmu7(t,x,y,z));
	f_mu.push_back(fmu8(t,x,y,z));
	f_mu.push_back(fmu9(t,x,y,z));
	f_mu.push_back(fmu10(t,x,y,z));
	f_mu.push_back(fmu11(t,x,y,z));
	f_mu.push_back(fmu12(t,x,y,z));
	f_mu.push_back(fmu13(t,x,y,z));
	f_mu.push_back(fmu14(t,x,y,z));
	f_mu.push_back(fmu15(t,x,y,z));
	f_mu.push_back(fmu16(t,x,y,z));
	f_mu.push_back(fmu17(t,x,y,z));
	f_mu.push_back(fmu18(t,x,y,z));
	f_mu.push_back(fmu19(t,x,y,z));
	f_mu.push_back(fmu20(t,x,y,z));
	f_mu.push_back(fmu21(t,x,y,z));
	f_mu.push_back(fmu22(t,x,y,z));
	f_mu.push_back(fmu23(t,x,y,z));
	f_mu.push_back(fmu24(t,x,y,z));
	f_mu.push_back(fmu25(t,x,y,z));
	f_mu.push_back(fmu26(t,x,y,z));

	f_mueq.push_back(fmueq0(t,x,y,z));
	f_mueq.push_back(fmueq1(t,x,y,z));
	f_mueq.push_back(fmueq2(t,x,y,z));
	f_mueq.push_back(fmueq3(t,x,y,z));
	f_mueq.push_back(fmueq4(t,x,y,z));
	f_mueq.push_back(fmueq5(t,x,y,z));
	f_mueq.push_back(fmueq6(t,x,y,z));
	f_mueq.push_back(fmueq7(t,x,y,z));
	f_mueq.push_back(fmueq8(t,x,y,z));
	f_mueq.push_back(fmueq9(t,x,y,z));
	f_mueq.push_back(fmueq10(t,x,y,z));
	f_mueq.push_back(fmueq11(t,x,y,z));
	f_mueq.push_back(fmueq12(t,x,y,z));
	f_mueq.push_back(fmueq13(t,x,y,z));
	f_mueq.push_back(fmueq14(t,x,y,z));
	f_mueq.push_back(fmueq15(t,x,y,z));
	f_mueq.push_back(fmueq16(t,x,y,z));
	f_mueq.push_back(fmueq17(t,x,y,z));
	f_mueq.push_back(fmueq18(t,x,y,z));
	f_mueq.push_back(fmueq19(t,x,y,z));
	f_mueq.push_back(fmueq20(t,x,y,z));
	f_mueq.push_back(fmueq21(t,x,y,z));
	f_mueq.push_back(fmueq22(t,x,y,z));
	f_mueq.push_back(fmueq23(t,x,y,z));
	f_mueq.push_back(fmueq24(t,x,y,z));
	f_mueq.push_back(fmueq25(t,x,y,z));
	f_mueq.push_back(fmueq26(t,x,y,z));
}

CORE::~CORE()
{
	if (allocated_tay)
	{
		if (use_tay_vels) { for (int d=0;d<DIM;d++) delete tay_vels[d]; delete [] tay_vels; }
	}

	if (allocated)
	{
		delete [] symB;
		delete [] As;

		for (int d=0;d<DIM;d++) delete [] sym_vels[d];
		delete [] sym_vels;
	}
}
